/******************************************************************************
 * matrix.h
 * Federico Bareilles
 * 08/02/2003
 *
 *
 *****************************************************************************/
#ifndef __MATRIX_H
#define __MATRIX_H

struct matrix{
  int d[2];
  double **M;
};

/* make the matrix: return pointer to new matrix */
struct matrix *make_matrix(int n, int m);

/* Only for testing */
int print_matrix(struct matrix *M);

int free_matrix(struct matrix *M);

/* return pointer off copy the struct matrix A */
struct matrix *copy_matrix(struct matrix *A);

/* return pointer to product A . B */
struct matrix *prod_matrix(struct matrix *A, struct matrix *B);

/* return pointer to transpuesta of matrix A */
struct matrix *trans_matrix(struct matrix *A);

/* return pointer to mino of A(ci|cj) */
struct matrix *sub_matrix(struct matrix *A, int ci, int cj);

/* return determinant of matrix M */
double det_matrix(struct matrix *M);

/* return pointer to adjunta of M */
struct matrix *adj_matrix(struct matrix *M);

/* return pointer to inversa of M; if |M| == 0 return NULL */
/* struct matrix *inv_matrix(struct matrix *M); */
struct matrix *inv_matrix_det(struct matrix *M);

/*  Factorization with pivoting */
struct matrix *LU_factorization(struct matrix *A, int *indv);
int LU_fact_vector(struct matrix *LU, struct matrix *V, int *indv);
struct matrix *LU_back_substitution(struct matrix *LU, 
				    struct matrix *V, int *indv);
struct matrix *LU_linear_resolv(struct matrix *A, struct matrix *V);
struct matrix *LU_inv_matrix(struct matrix *M);

//#define inv_matrix inv_matrix_det
#define inv_matrix LU_inv_matrix

#endif
